freedombone-app-riot 12KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # Riot Web user interface for Matrix
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2017-2018 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full full-vim chat'
  31. IN_DEFAULT_INSTALL=0
  32. SHOW_ON_ABOUT=1
  33. RIOT_VERSION='0.13.3'
  34. RIOT_FILENAME="riot-v${RIOT_VERSION}"
  35. RIOT_HASH='bcd6c2f4be018612ac76a71b58749a5edab1e02de7d145a22d9b9aa6e6a89129'
  36. RIOT_DOWNLOAD_URL="https://github.com/vector-im/riot-web/releases/download/v${RIOT_VERSION}"
  37. RIOT_ONION_PORT=8115
  38. RIOT_ONION_HOSTNAME=
  39. RIOT_DOMAIN_NAME=
  40. RIOT_CODE=
  41. riot_variables=(MY_USERNAME
  42. RIOT_DOMAIN_NAME
  43. MATRIX_DOMAIN_NAME
  44. SYSTEM_TYPE
  45. ONION_ONLY
  46. DDNS_PROVIDER)
  47. function logging_on_riot {
  48. echo -n ''
  49. }
  50. function logging_off_riot {
  51. echo -n ''
  52. }
  53. function remove_user_riot {
  54. echo -n ''
  55. }
  56. function add_user_riot {
  57. echo '0'
  58. }
  59. function riot_remove_bad_links {
  60. sed -i '/riot.im/d' /var/www/$RIOT_DOMAIN_NAME/htdocs/home.html
  61. }
  62. function install_interactive_riot {
  63. if [[ $ONION_ONLY != "no" ]]; then
  64. RIOT_DOMAIN_NAME='riot.local'
  65. else
  66. RIOT_DETAILS_COMPLETE=
  67. while [ ! $RIOT_DETAILS_COMPLETE ]
  68. do
  69. data=$(mktemp 2>/dev/null)
  70. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  71. dialog --backtitle $"Freedombone Configuration" \
  72. --title $"Riot Web user interface for Matrix" \
  73. --form $"\\nPlease enter your details.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 13 65 3 \
  74. $"Domain:" 1 1 "$(grep 'RIOT_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 15 40 40 \
  75. $"Code:" 2 1 "$(grep 'RIOT_CODE' temp.cfg | awk -F '=' '{print $2}')" 2 15 40 255 \
  76. 2> "$data"
  77. else
  78. dialog --backtitle $"Freedombone Configuration" \
  79. --title $"Riot Web user interface for Matrix" \
  80. --form $"\\nPlease enter your details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 13 65 2 \
  81. $"Domain:" 1 1 "$(grep 'RIOT_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 15 40 40 \
  82. 2> "$data"
  83. fi
  84. sel=$?
  85. case $sel in
  86. 1) rm -f "$data"
  87. exit 1;;
  88. 255) rm -f "$data"
  89. exit 1;;
  90. esac
  91. RIOT_DOMAIN_NAME=$(sed -n 1p < "$data")
  92. if [ "$RIOT_DOMAIN_NAME" ]; then
  93. TEST_DOMAIN_NAME=$RIOT_DOMAIN_NAME
  94. validate_domain_name
  95. if [[ "$TEST_DOMAIN_NAME" != "$RIOT_DOMAIN_NAME" ]]; then
  96. RIOT_DOMAIN_NAME=
  97. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  98. else
  99. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  100. RIOT_CODE=$(sed -n 2p < "$data")
  101. validate_freedns_code "$RIOT_CODE"
  102. if [ ! "$VALID_CODE" ]; then
  103. RIOT_DOMAIN_NAME=
  104. fi
  105. fi
  106. fi
  107. fi
  108. if [ $RIOT_DOMAIN_NAME ]; then
  109. RIOT_DETAILS_COMPLETE="yes"
  110. fi
  111. rm -f "$data"
  112. done
  113. # save the results in the config file
  114. write_config_param "RIOT_CODE" "$RIOT_CODE"
  115. fi
  116. write_config_param "RIOT_DOMAIN_NAME" "$RIOT_DOMAIN_NAME"
  117. APP_INSTALLED=1
  118. }
  119. function reconfigure_riot {
  120. echo -n ''
  121. }
  122. function riot_download {
  123. # download
  124. if [ ! -f "$INSTALL_DIR/${RIOT_FILENAME}.tar.gz" ]; then
  125. wget "${RIOT_DOWNLOAD_URL}/${RIOT_FILENAME}.tar.gz" -O "$INSTALL_DIR/${RIOT_FILENAME}.tar.gz"
  126. fi
  127. if [ ! -f "$INSTALL_DIR/${RIOT_FILENAME}.tar.gz" ]; then
  128. echo $'Unable to download Riot Web from releases'
  129. exit 62836
  130. fi
  131. cd "$INSTALL_DIR" || exit 2468724628
  132. # check the hash
  133. curr_hash=$(sha256sum ${RIOT_FILENAME}.tar.gz | awk -F ' ' '{print $1}')
  134. if [[ "$curr_hash" != "$RIOT_HASH" ]]; then
  135. echo $'Riot download hash does not match'
  136. exit 78352
  137. fi
  138. tar -xzvf ${RIOT_FILENAME}.tar.gz
  139. if [ ! -d "$INSTALL_DIR/${RIOT_FILENAME}" ]; then
  140. echo $'Unable to extract Riot Web tarball'
  141. exit 542826
  142. fi
  143. cp -r "$INSTALL_DIR/${RIOT_FILENAME}/"* "/var/www/$RIOT_DOMAIN_NAME/htdocs"
  144. chown -R www-data:www-data "/var/www/$RIOT_DOMAIN_NAME/htdocs"
  145. }
  146. function upgrade_riot {
  147. if ! grep -q 'riot version:' "$COMPLETION_FILE"; then
  148. return
  149. fi
  150. CURR_RIOT_VERSION=$(get_completion_param "riot version")
  151. echo "riot current version: ${CURR_RIOT_VERSION}"
  152. echo "riot app version: ${RIOT_VERSION}"
  153. if [[ "${CURR_RIOT_VERSION}" == "${RIOT_VERSION}" ]]; then
  154. return
  155. fi
  156. riot_download
  157. sed -i "s|riot version.*|riot version:$RIOT_VERSION|g" "${COMPLETION_FILE}"
  158. riot_remove_bad_links
  159. systemctl restart nginx
  160. }
  161. function backup_local_riot {
  162. echo -n ''
  163. }
  164. function restore_local_riot {
  165. echo -n ''
  166. }
  167. function backup_remote_riot {
  168. echo -n ''
  169. }
  170. function restore_remote_riot {
  171. echo -n ''
  172. }
  173. function remove_riot {
  174. function_check remove_onion_service
  175. remove_onion_service riot ${RIOT_ONION_PORT}
  176. nginx_dissite $RIOT_DOMAIN_NAME
  177. if [ -f /etc/nginx/sites-available/$RIOT_DOMAIN_NAME ]; then
  178. rm /etc/nginx/sites-available/$RIOT_DOMAIN_NAME
  179. fi
  180. if [ -d /var/www/$RIOT_DOMAIN_NAME ]; then
  181. rm -rf /var/www/$RIOT_DOMAIN_NAME
  182. fi
  183. remove_completion_param install_riot
  184. sed -i '/riot /d' "$COMPLETION_FILE"
  185. }
  186. function install_riot {
  187. if [[ $ONION_ONLY != 'no' ]]; then
  188. return
  189. fi
  190. # check that matrix has been installed
  191. if [ ! "$MATRIX_DOMAIN_NAME" ]; then
  192. exit 687292
  193. fi
  194. if [[ "$MATRIX_DOMAIN_NAME" != *'.'* ]]; then
  195. exit 256288
  196. fi
  197. if [ ! -d /var/lib/matrix ]; then
  198. exit 827334
  199. fi
  200. function_check get_completion_param
  201. MATRIX_ONION_DOMAIN_NAME=$(get_completion_param "matrix onion domain")
  202. apt-get -yq install wget
  203. if [ ! -d /var/www/$RIOT_DOMAIN_NAME/htdocs ]; then
  204. mkdir -p /var/www/$RIOT_DOMAIN_NAME/htdocs
  205. fi
  206. if [ ! -d "$INSTALL_DIR" ]; then
  207. mkdir "$INSTALL_DIR"
  208. fi
  209. riot_download
  210. cd "/var/www/$RIOT_DOMAIN_NAME/htdocs" || exit 4628462876
  211. if [[ "$ONION_ONLY" == 'no' ]]; then
  212. riot_config_file="config.${RIOT_DOMAIN_NAME}.json"
  213. cp config.sample.json $riot_config_file
  214. sed -i "s|\"default_hs_url\":.*|\"default_hs_url\": \"https://${MATRIX_DOMAIN_NAME}\",|g" "$riot_config_file"
  215. sed -i "s|\"default_is_url\":.*|\"default_is_url\": \"https://${MATRIX_DOMAIN_NAME}\",|g" "$riot_config_file"
  216. sed -i "s|\"bug_report_endpoint_url\":.*|\"bug_report_endpoint_url\": \"https://${MATRIX_DOMAIN_NAME}/bugs\",|g" "$riot_config_file"
  217. sed -i "/\"servers\":/a \"${MATRIX_DOMAIN_NAME}\"," "$riot_config_file"
  218. else
  219. riot_config_file="config.${MATRIX_ONION_DOMAIN_NAME}.json"
  220. cp config.sample.json "$riot_config_file"
  221. sed -i "s|\"default_hs_url\":.*|\"default_hs_url\": \"http://${MATRIX_ONION_DOMAIN_NAME}\",|g" "$riot_config_file"
  222. sed -i "s|\"default_is_url\":.*|\"default_is_url\": \"http://${MATRIX_ONION_DOMAIN_NAME}\",|g" "$riot_config_file"
  223. sed -i "s|\"bug_report_endpoint_url\":.*|\"bug_report_endpoint_url\": \"http://${MATRIX_ONION_DOMAIN_NAME}/bugs\",|g" "$riot_config_file"
  224. sed -i "/\"servers\":/a \"${MATRIX_ONION_DOMAIN_NAME}\"," "$riot_config_file"
  225. fi
  226. sed -i "s|\"integrations_ui_url\":.*|\"integrations_ui_url\": \"\",|g" "$riot_config_file"
  227. sed -i "s|\"integrations_rest_url\":.*|\"integrations_rest_url\": \"\",|g" "$riot_config_file"
  228. sed -i 's|https://piwik.riot.im/||g' "$riot_config_file"
  229. RIOT_ONION_HOSTNAME=$(add_onion_service riot 80 ${RIOT_ONION_PORT})
  230. riot_nginx_site=/etc/nginx/sites-available/$RIOT_DOMAIN_NAME
  231. if [[ $ONION_ONLY == "no" ]]; then
  232. function_check nginx_http_redirect
  233. nginx_http_redirect $RIOT_DOMAIN_NAME
  234. { echo 'server {';
  235. echo ' listen 443 ssl;';
  236. echo ' #listen [::]:443 ssl;';
  237. echo " server_name $RIOT_DOMAIN_NAME;";
  238. echo '';
  239. echo ' # Security'; } >> $riot_nginx_site
  240. function_check nginx_ssl
  241. nginx_ssl $RIOT_DOMAIN_NAME
  242. function_check nginx_security_options
  243. nginx_security_options $RIOT_DOMAIN_NAME
  244. { echo ' add_header Strict-Transport-Security max-age=15768000;';
  245. echo '';
  246. echo ' # Logs';
  247. echo ' access_log /dev/null;';
  248. echo ' error_log /dev/null;';
  249. echo '';
  250. echo ' # Root';
  251. echo " root /var/www/$RIOT_DOMAIN_NAME/htdocs;";
  252. echo '';
  253. echo ' index index.html;';
  254. echo '';
  255. echo ' location / {'; } >> $riot_nginx_site
  256. function_check nginx_limits
  257. nginx_limits $RIOT_DOMAIN_NAME '15m'
  258. { echo ' }';
  259. echo '}';
  260. echo ''; } >> $riot_nginx_site
  261. else
  262. echo -n '' > $riot_nginx_site
  263. fi
  264. { echo 'server {';
  265. echo " listen 127.0.0.1:$RIOT_ONION_PORT default_server;";
  266. echo " server_name $RIOT_ONION_HOSTNAME;";
  267. echo ''; } >> $riot_nginx_site
  268. function_check nginx_security_options
  269. nginx_security_options $RIOT_DOMAIN_NAME
  270. { echo '';
  271. echo ' # Logs';
  272. echo ' access_log /dev/null;';
  273. echo ' error_log /dev/null;';
  274. echo '';
  275. echo ' # Root';
  276. echo " root /var/www/$RIOT_DOMAIN_NAME/htdocs;";
  277. echo '';
  278. echo ' index index.html;';
  279. echo '';
  280. echo ' location / {'; } >> $riot_nginx_site
  281. function_check nginx_limits
  282. nginx_limits $RIOT_DOMAIN_NAME '15m'
  283. echo ' }' >> "$riot_nginx_site"
  284. echo '}' >> "$riot_nginx_site"
  285. sed '/Content-Security-Policy/d' "$riot_nginx_site"
  286. sed -i 's| DENY;| SAMEORIGIN;|g' "$riot_nginx_site"
  287. sed -i 's|limit_conn conn_limit_per_ip.*|limit_conn conn_limit_per_ip 50;|g' "$riot_nginx_site"
  288. sed -i 's|limit_req zone.*|limit_req zone=req_limit_per_ip burst=20 nodelay;|g' "$riot_nginx_site"
  289. function_check create_site_certificate
  290. if [ ! -f "/etc/ssl/certs/${RIOT_DOMAIN_NAME}.pem" ]; then
  291. create_site_certificate "$RIOT_DOMAIN_NAME" 'yes'
  292. fi
  293. function_check nginx_ensite
  294. nginx_ensite $RIOT_DOMAIN_NAME
  295. function_check add_ddns_domain
  296. add_ddns_domain $RIOT_DOMAIN_NAME
  297. riot_remove_bad_links
  298. chown -R www-data:www-data /var/www/$RIOT_DOMAIN_NAME/htdocs
  299. systemctl restart nginx
  300. set_completion_param "riot domain" "$RIOT_DOMAIN_NAME"
  301. if ! grep -q "riot version:" "${COMPLETION_FILE}"; then
  302. echo "riot version:${RIOT_VERSION}" >> "${COMPLETION_FILE}"
  303. else
  304. sed -i "s|riot version.*|riot version:${RIOT_VERSION}|g" "${COMPLETION_FILE}"
  305. fi
  306. APP_INSTALLED=1
  307. }
  308. # NOTE: deliberately no exit 0